
/*----------------------------------------------------------------------------*

	LinuxInfo_alpha.c
		by Alex Buell
			September 1998

 ----------------------------------------------------------------------------- 

	Handles the Alpha architecture	

 ----------------------------------------------------------------------------- 

	HISTORY

	1.01 - Initial development

 -----------------------------------------------------------------------------*/

#include "linuxinfo.h"

#ifdef system_alpha

void GetHardwareInfo(struct hw_stat *hw)
{
	int processors = 0; 
	float bogomips = 0.0;
	float tempbogo;
	LONGLONG memory = 0;

	char temp_string[BUFSIZ], temp_string2[BUFSIZ];
	char chip[BUFSIZ], vendor[BUFSIZ], model[BUFSIZ] = "Unknown";

	FILE *procfile;
	struct stat st_buf;

	if ((procfile = fopen(CPUINFO_FILE, "r")) != NULL) 
	{
		while (fscanf(procfile, "%s", (char *)&temp_string2) != EOF) 
		{
			if (processors == 0) 
			{
				if (!(strcmp(temp_string2, "model"))) 
				{
					fscanf(procfile, "%s", (char *)&temp_string);
					GetStringFromFile(procfile, (char *)&model);
					sscanf(model, "%s", (char *)&temp_string);
				}
			}
			if (!(strcmp(temp_string2, "BogoMIPS")))
			{
				processors++;
				fscanf(procfile, "%s%f", (char *)&hw->hw_bogomips, &tempbogo);
				bogomips += tempbogo;
			}
		}
		fclose(procfile);
	}

	stat(MEMORY_FILE, &st_buf);
	memory = st_buf.st_size;
	memory /= 1024; memory /= 1024;
	sprintf(hw->hw_memory, "%ld", (long int)memory);

	hw->hw_processors = processors;

	sprintf(hw->hw_cpuinfo, "Alpha %s", model);
	sprintf(hw->hw_bogomips, "%0.2f", bogomips);
}

#endif /* system_alpha */
